设为首页收藏本站

晓东CAD家园-论坛

 找回密码
 立即注册

QQ登录

只需一步,快速开始

扫一扫,访问微社区

12
返回列表 发新帖
楼主: Lispboy

[选择集] (XD::Pickset:Drag)灵活**定制的**拷贝、移动拖动选择集函数

[复制链接]

签到天数: 376 天

连续签到: 2 天

[LV.9]以坛为家II

已领礼包: 51个

财富等级: 招财进宝

 楼主| 发表于 2013-7-27 23:57:03 | 显示全部楼层
liuyj 发表于 2013-7-27 22:30
XD::UndoMark和XD::Undoend函数好像没发布过。

是的,内部使用了。

其实没什么,就是把vla-startUndoMark和 vla-endUndoMark 给包装个名字。

  1. (setq **XD::Doc** (vla-get-activedocument (vlax-get-acad-object)))
  2. (setq **XD::MSpace** (vla-get-modelspace **XD::Doc**))


  3. (defun XD::UndoMark ()
  4.   (vla-startundomark **XD::Doc**)
  5. )
  6. (defun XD::UndoEnd ()
  7.   (vla-endundomark **XD::Doc**)
  8. )


论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

签到天数: 122 天

连续签到: 3 天

[LV.7]常住居民III

已领礼包: 193个

财富等级: 日进斗金

发表于 2014-11-6 07:33:28 | 显示全部楼层
是好东西,
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复

使用道具 举报

签到天数: 67 天

连续签到: 1 天

[LV.6]常住居民II

发表于 2015-12-4 23:46:58 | 显示全部楼层
这个挺强大
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

签到天数: 12 天

连续签到: 2 天

[LV.3]偶尔看看II

发表于 2016-4-29 21:36:20 | 显示全部楼层
光看就觉得这个很牛了
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

签到天数: 1273 天

连续签到: 17 天

[LV.10]以坛为家III

点击这里给我发消息

已领礼包: 144个

财富等级: 日进斗金

发表于 2016-5-26 13:27:30 | 显示全部楼层
该函数2016.0526日更新,支持一键回车。 插件 **移动,**拷贝支持一键回车。
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

签到天数: 1839 天

连续签到: 18 天

[LV.Master]伴坛终老I

已领礼包: 5083个

财富等级: 富甲天下

发表于 2016-5-26 14:00:49 | 显示全部楼层
终于更新了,可仍有两个问题没有解决:
1、复制带扩展数据的实体,复制出来的数据丢失了;
2、xdrx_PickSet_dragGen的返回值经常是-4,没有什么规律,导致连续复制中断。我希望是单击鼠标右键或按esc键时得到-4,否则强制连续复制。鼠标右键用acet-sys-lmouse-down好判断,但esc没有办法。
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

签到天数: 1839 天

连续签到: 18 天

[LV.Master]伴坛终老I

已领礼包: 5083个

财富等级: 富甲天下

发表于 2016-5-26 14:53:29 | 显示全部楼层
似乎只有图块会发生扩展数据丢失的情况
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

签到天数: 116 天

连续签到: 2 天

[LV.6]常住居民II

已领礼包: 56个

财富等级: 招财进宝

发表于 2017-9-11 18:53:46 来自手机 | 显示全部楼层
这里有两次转换,一次转换可以么?不大理解
Screenshot_20170911-175024.jpg
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

签到天数: 1027 天

连续签到: 17 天

[LV.10]以坛为家III

已领礼包: 40个

财富等级: 招财进宝

发表于 2017-9-11 22:17:26 | 显示全部楼层

不是两次转换,变量是一个,值按最后那个为准,前面的应该是调试时候后来忘记删除了。
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

签到天数: 116 天

连续签到: 2 天

[LV.6]常住居民II

已领礼包: 56个

财富等级: 招财进宝

发表于 2017-9-12 07:43:02 来自手机 | 显示全部楼层
哦 明白了 谢谢
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

签到天数: 116 天

连续签到: 2 天

[LV.6]常住居民II

已领礼包: 56个

财富等级: 招财进宝

发表于 2017-9-26 20:12:48 来自手机 | 显示全部楼层
这个怎么才能让文字镜像呢?看了论坛一篇帖子,没有给出解决办法
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

签到天数: 116 天

连续签到: 2 天

[LV.6]常住居民II

已领礼包: 56个

财富等级: 招财进宝

发表于 2017-9-27 00:02:51 | 显示全部楼层
这个文字镜像后是反的 按这个帖子可以解决 效果不理想。http://bbs.xdcad.net/thread-675661-1-1.html

  1. ((= mRMatrix "S")
  2.        (setq mTMatrix (xdrx_matrix_product
  3.                         (xdrx_matrix_setMirror
  4.                           mTMatrix0
  5.                           (list        (trans pj 1 0)
  6.                                 (trans (polar pj (/ pi 2) 100) 1 0)
  7.                           )
  8.                         )
  9.                         (xdrx_matrix_setmirror
  10.                           (xdrx_matrix_identity)
  11.                           '((0 0 0) (1 0 0) (0 1 0))
  12.                         )
  13.                       )
  14.        )
  15.        (xdrx_drag_setmatrix mTMatrix nil)
  16.       )



按如上方法解决后,拖动过程文字仍然是反的,但鼠标确定后文字方向是正常的。
xdrx_PickSet_dragGen这个函数能修改一下,让拖动过程文字也是正常的么
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

签到天数: 1839 天

连续签到: 18 天

[LV.Master]伴坛终老I

已领礼包: 5083个

财富等级: 富甲天下

发表于 2017-9-27 01:17:01 | 显示全部楼层
本帖最后由 liuyj 于 2017-9-27 01:18 编辑

我这么弄的,对复制后的选择集中的文字过滤出来再处理,办法比较笨,不过效果还行
  1. (setq
  2.              entlist (xd::list:groupbyindex
  3.                        (mapcar
  4.                          '(lambda (x)
  5.                             (list (xdrx_getpropertyvalue x "IsA") x)
  6.                           )
  7.                          (xdrx_pickset->ents ss)
  8.                        )
  9.                        0
  10.                      )
  11.            )
  12.            (setq entlist1 (cdr (assoc "AcDbText" entlist))
  13.                  entlist2 (cdr (assoc "AcDbMText" entlist))
  14.            )
  15.            (if (setq entlist (append entlist1 entlist2))
  16.              (progn (setq vdir (getvar "viewdir"))
  17.                     (mapcar '(lambda (x)
  18.                                (setq zdir1 (xdrx_getpropertyvalue x "normal")
  19.                                      pt           (xd::geom:get9pt x 5)
  20.                                )
  21.                                (if (and        (equal vdir '(0.0 0.0 1.0) 1e-5)
  22.                                         (equal zdir1 '(0.0 0.0 -1.0) 1e-5)
  23.                                    )
  24.                                  (progn        (xdrx_setpropertyvalue
  25.                                           x
  26.                                           "normal"
  27.                                           (xdrx_vector_negate zdir1)
  28.                                         )
  29.                                         (vl-cmdf ".Move" x "" (xd::geom:get9pt x 5) pt)
  30.                                  )
  31.                                )
  32.                              )
  33.                             entlist
  34.                     )
  35.              )
  36.            )

论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

您需要登录后才可以回帖 登录 | 立即注册

本版积分规则

QQ|申请友链|小黑屋|手机版|Archiver|辽公网安备|晓东CAD家园 ( 辽ICP备15016793号 )  

GMT+8, 2018-6-21 05:17 , Processed in 0.198428 second(s), 56 queries , Gzip On, WinCache On.

Powered by Discuz! X3.4

© 2001-2017 Comsenz Inc.

快速回复 返回顶部 返回列表